package me.wazup.hideandseek.custommaps;

import java.util.Iterator;
import org.bukkit.inventory.meta.ItemMeta;
import java.lang.reflect.InvocationTargetException;
import me.wazup.hideandseek.xseries.XMaterial;
import org.bukkit.Bukkit;
import org.bukkit.World;
import org.bukkit.map.MapRenderer;
import org.bukkit.map.MapView;
import org.bukkit.inventory.meta.MapMeta;
import java.lang.reflect.Method;
import org.bukkit.inventory.ItemStack;
import java.util.HashMap;

public class CustomMapsManager
{
    private final HashMap<String, ItemStack> maps;
    private Method setMapId;
    private Method setMapView;
    
    public CustomMapsManager() {
        this.maps = new HashMap<String, ItemStack>();
        try {
            this.setMapView = MapMeta.class.getDeclaredMethod("setMapView", MapView.class);
        }
        catch (final NoSuchMethodException | SecurityException ex) {
            try {
                this.setMapId = MapMeta.class.getDeclaredMethod("setMapId", Integer.TYPE);
            }
            catch (final NoSuchMethodException | SecurityException ex2) {}
        }
    }
    
    public void clear() {
        this.maps.clear();
    }
    
    public void registerMap(final String key, final MapRenderer mapRenderer) {
        final MapView map = Bukkit.createMap((World)Bukkit.getWorlds().get(0));
        final Iterator iterator = map.getRenderers().iterator();
        while (iterator.hasNext()) {
            map.removeRenderer((MapRenderer)iterator.next());
        }
        map.addRenderer(mapRenderer);
        final ItemStack item = XMaterial.FILLED_MAP.parseItem();
        if (this.setMapView != null || this.setMapId != null) {
            final MapMeta itemMeta = (MapMeta)item.getItemMeta();
            if (this.setMapView != null) {
                try {
                    this.setMapView.invoke(itemMeta, map);
                }
                catch (final IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
                    ((Throwable)ex).printStackTrace();
                }
            }
            else {
                try {
                    this.setMapId.invoke(itemMeta, this.getViewId(map));
                }
                catch (final IllegalAccessException | IllegalArgumentException | InvocationTargetException ex2) {
                    ((Throwable)ex2).printStackTrace();
                }
            }
            item.setItemMeta((ItemMeta)itemMeta);
        }
        else {
            item.setDurability((short)this.getViewId(map));
        }
        this.maps.put(key, item);
    }
    
    private int getViewId(final MapView obj) {
        try {
            return Integer.valueOf(MapView.class.getMethod("getId", (Class<?>[])new Class[0]).invoke(obj, new Object[0]).toString());
        }
        catch (final IllegalAccessException | IllegalArgumentException | InvocationTargetException | NoSuchMethodException | SecurityException ex) {
            ((Throwable)ex).printStackTrace();
            return -1;
        }
    }
    
    public boolean isRegistered(final String key) {
        return this.maps.containsKey(key);
    }
    
    public ItemStack getItemStack(final String key) {
        return this.maps.get(key);
    }
}
